diff --git a/src/mongo/db/pipeline/document_source_densify.h b/src/mongo/db/pipeline/document_source/document_source_densify.h
similarity index 98%
rename from src/mongo/db/pipeline/document_source_densify.h
rename to src/mongo/db/pipeline/document_source/document_source_densify.h
index 6320af4709..f4872293ee 100644
--- a/src/mongo/db/pipeline/document_source_densify.h
+++ b/src/mongo/db/pipeline/document_source/document_source_densify.h
@@ -31,7 +31,7 @@
 
 #include "mongo/db/exec/document_value/document.h"
 #include "mongo/db/exec/document_value/value.h"
-#include "mongo/db/pipeline/document_source.h"
+#include "mongo/db/pipeline/document_source/document_source.h"
 #include "mongo/db/pipeline/field_path.h"
 #include "mongo/db/query/datetime/date_time_support.h"
 #include "mongo/util/time_support.h"
diff --git a/src/mongo/db/pipeline/document_source_exchange.cpp b/src/mongo/db/pipeline/document_source/document_source_exchange.cpp
similarity index 99%
rename from src/mongo/db/pipeline/document_source_exchange.cpp
rename to src/mongo/db/pipeline/document_source/document_source_exchange.cpp
index 931b78f316..432a59fcb9 100644
--- a/src/mongo/db/pipeline/document_source_exchange.cpp
+++ b/src/mongo/db/pipeline/document_source/document_source_exchange.cpp
@@ -37,7 +37,7 @@
 
 #include "mongo/db/curop.h"
 #include "mongo/db/hasher.h"
-#include "mongo/db/pipeline/document_source_exchange.h"
+#include "mongo/db/pipeline/document_source/document_source_exchange.h"
 #include "mongo/db/storage/key_string.h"
 #include "mongo/logv2/log.h"
 
diff --git a/src/mongo/db/pipeline/document_source_exchange.h b/src/mongo/db/pipeline/document_source/document_source_exchange.h
similarity index 99%
rename from src/mongo/db/pipeline/document_source_exchange.h
rename to src/mongo/db/pipeline/document_source/document_source_exchange.h
index ab69ed3b01..9ee7ac5903 100644
--- a/src/mongo/db/pipeline/document_source_exchange.h
+++ b/src/mongo/db/pipeline/document_source/document_source_exchange.h
@@ -33,7 +33,7 @@
 #include <vector>
 
 #include "mongo/bson/ordering.h"
-#include "mongo/db/pipeline/document_source.h"
+#include "mongo/db/pipeline/document_source/document_source.h"
 #include "mongo/db/pipeline/exchange_spec_gen.h"
 #include "mongo/db/pipeline/field_path.h"
 #include "mongo/platform/mutex.h"
diff --git a/src/mongo/db/pipeline/document_source_exchange_test.cpp b/src/mongo/db/pipeline/document_source/document_source_exchange_test.cpp
similarity index 99%
rename from src/mongo/db/pipeline/document_source_exchange_test.cpp
rename to src/mongo/db/pipeline/document_source/document_source_exchange_test.cpp
index ac234357b1..fcd731d222 100644
--- a/src/mongo/db/pipeline/document_source_exchange_test.cpp
+++ b/src/mongo/db/pipeline/document_source/document_source_exchange_test.cpp
@@ -33,8 +33,8 @@
 
 #include "mongo/db/hasher.h"
 #include "mongo/db/pipeline/aggregation_context_fixture.h"
-#include "mongo/db/pipeline/document_source_exchange.h"
-#include "mongo/db/pipeline/document_source_mock.h"
+#include "mongo/db/pipeline/document_source/document_source_exchange.h"
+#include "mongo/db/pipeline/document_source/document_source_mock.h"
 #include "mongo/db/storage/key_string.h"
 #include "mongo/executor/network_interface_factory.h"
 #include "mongo/executor/thread_pool_task_executor.h"
diff --git a/src/mongo/db/pipeline/document_source_facet.cpp b/src/mongo/db/pipeline/document_source/document_source_facet.cpp
similarity index 99%
rename from src/mongo/db/pipeline/document_source_facet.cpp
rename to src/mongo/db/pipeline/document_source/document_source_facet.cpp
index 2cee70a250..e471785830 100644
--- a/src/mongo/db/pipeline/document_source_facet.cpp
+++ b/src/mongo/db/pipeline/document_source/document_source_facet.cpp
@@ -29,7 +29,7 @@
 
 #include "mongo/platform/basic.h"
 
-#include "mongo/db/pipeline/document_source_facet.h"
+#include "mongo/db/pipeline/document_source/document_source_facet.h"
 
 #include <memory>
 #include <vector>
@@ -40,7 +40,7 @@
 #include "mongo/bson/bsontypes.h"
 #include "mongo/db/exec/document_value/document.h"
 #include "mongo/db/exec/document_value/value.h"
-#include "mongo/db/pipeline/document_source_tee_consumer.h"
+#include "mongo/db/pipeline/document_source/document_source_tee_consumer.h"
 #include "mongo/db/pipeline/expression_context.h"
 #include "mongo/db/pipeline/field_path.h"
 #include "mongo/db/pipeline/pipeline.h"
diff --git a/src/mongo/db/pipeline/document_source_facet.h b/src/mongo/db/pipeline/document_source/document_source_facet.h
similarity index 99%
rename from src/mongo/db/pipeline/document_source_facet.h
rename to src/mongo/db/pipeline/document_source/document_source_facet.h
index f5c18e4352..271ff339e6 100644
--- a/src/mongo/db/pipeline/document_source_facet.h
+++ b/src/mongo/db/pipeline/document_source/document_source_facet.h
@@ -34,7 +34,7 @@
 #include <memory>
 #include <vector>
 
-#include "mongo/db/pipeline/document_source.h"
+#include "mongo/db/pipeline/document_source/document_source.h"
 #include "mongo/db/pipeline/lite_parsed_document_source.h"
 #include "mongo/db/pipeline/lite_parsed_pipeline.h"
 #include "mongo/db/pipeline/pipeline.h"
diff --git a/src/mongo/db/pipeline/document_source_facet_test.cpp b/src/mongo/db/pipeline/document_source/document_source_facet_test.cpp
similarity index 99%
rename from src/mongo/db/pipeline/document_source_facet_test.cpp
rename to src/mongo/db/pipeline/document_source/document_source_facet_test.cpp
index 44e3d9668e..849de21590 100644
--- a/src/mongo/db/pipeline/document_source_facet_test.cpp
+++ b/src/mongo/db/pipeline/document_source/document_source_facet_test.cpp
@@ -29,7 +29,7 @@
 
 #include "mongo/platform/basic.h"
 
-#include "mongo/db/pipeline/document_source_facet.h"
+#include "mongo/db/pipeline/document_source/document_source_facet.h"
 
 #include <deque>
 #include <vector>
@@ -41,9 +41,9 @@
 #include "mongo/db/exec/document_value/document.h"
 #include "mongo/db/exec/document_value/document_value_test_util.h"
 #include "mongo/db/pipeline/aggregation_context_fixture.h"
-#include "mongo/db/pipeline/document_source_limit.h"
-#include "mongo/db/pipeline/document_source_mock.h"
-#include "mongo/db/pipeline/document_source_skip.h"
+#include "mongo/db/pipeline/document_source/document_source_limit.h"
+#include "mongo/db/pipeline/document_source/document_source_mock.h"
+#include "mongo/db/pipeline/document_source/document_source_skip.h"
 #include "mongo/unittest/death_test.h"
 #include "mongo/unittest/unittest.h"
 
diff --git a/src/mongo/db/pipeline/document_source_geo_near.cpp b/src/mongo/db/pipeline/document_source/document_source_geo_near.cpp
similarity index 98%
rename from src/mongo/db/pipeline/document_source_geo_near.cpp
rename to src/mongo/db/pipeline/document_source/document_source_geo_near.cpp
index a5b4978855..7c34f52517 100644
--- a/src/mongo/db/pipeline/document_source_geo_near.cpp
+++ b/src/mongo/db/pipeline/document_source/document_source_geo_near.cpp
@@ -31,10 +31,10 @@
 
 #include "mongo/platform/basic.h"
 
-#include "mongo/db/pipeline/document_source_geo_near.h"
+#include "mongo/db/pipeline/document_source/document_source_geo_near.h"
 
 #include "mongo/db/exec/document_value/document.h"
-#include "mongo/db/pipeline/document_source_sort.h"
+#include "mongo/db/pipeline/document_source/document_source_sort.h"
 #include "mongo/db/pipeline/lite_parsed_document_source.h"
 #include "mongo/logv2/log.h"
 
diff --git a/src/mongo/db/pipeline/document_source_geo_near.h b/src/mongo/db/pipeline/document_source/document_source_geo_near.h
similarity index 98%
rename from src/mongo/db/pipeline/document_source_geo_near.h
rename to src/mongo/db/pipeline/document_source/document_source_geo_near.h
index b4bc3c460e..308df2aea6 100644
--- a/src/mongo/db/pipeline/document_source_geo_near.h
+++ b/src/mongo/db/pipeline/document_source/document_source_geo_near.h
@@ -29,7 +29,7 @@
 
 #pragma once
 
-#include "mongo/db/pipeline/document_source.h"
+#include "mongo/db/pipeline/document_source/document_source.h"
 #include "mongo/db/pipeline/field_path.h"
 
 namespace mongo {
diff --git a/src/mongo/db/pipeline/document_source_geo_near_cursor.cpp b/src/mongo/db/pipeline/document_source/document_source_geo_near_cursor.cpp
similarity index 95%
rename from src/mongo/db/pipeline/document_source_geo_near_cursor.cpp
rename to src/mongo/db/pipeline/document_source/document_source_geo_near_cursor.cpp
index 8e6885567d..fa78b1d117 100644
--- a/src/mongo/db/pipeline/document_source_geo_near_cursor.cpp
+++ b/src/mongo/db/pipeline/document_source/document_source_geo_near_cursor.cpp
@@ -29,7 +29,7 @@
 
 #include "mongo/platform/basic.h"
 
-#include "mongo/db/pipeline/document_source_geo_near_cursor.h"
+#include "mongo/db/pipeline/document_source/document_source_geo_near_cursor.h"
 
 #include <boost/intrusive_ptr.hpp>
 #include <boost/optional.hpp>
@@ -42,8 +42,8 @@
 #include "mongo/bson/simple_bsonobj_comparator.h"
 #include "mongo/db/catalog/collection.h"
 #include "mongo/db/exec/document_value/document.h"
-#include "mongo/db/pipeline/document_source_cursor.h"
-#include "mongo/db/pipeline/document_source_sort.h"
+#include "mongo/db/pipeline/document_source/document_source_cursor.h"
+#include "mongo/db/pipeline/document_source/document_source_sort.h"
 #include "mongo/db/pipeline/expression_context.h"
 #include "mongo/db/pipeline/field_path.h"
 #include "mongo/db/query/plan_executor.h"
diff --git a/src/mongo/db/pipeline/document_source_geo_near_cursor.h b/src/mongo/db/pipeline/document_source/document_source_geo_near_cursor.h
similarity index 98%
rename from src/mongo/db/pipeline/document_source_geo_near_cursor.h
rename to src/mongo/db/pipeline/document_source/document_source_geo_near_cursor.h
index b3ddf9a834..40559306ab 100644
--- a/src/mongo/db/pipeline/document_source_geo_near_cursor.h
+++ b/src/mongo/db/pipeline/document_source/document_source_geo_near_cursor.h
@@ -38,7 +38,7 @@
 #include "mongo/bson/bsonobj.h"
 #include "mongo/db/catalog/collection.h"
 #include "mongo/db/exec/document_value/document.h"
-#include "mongo/db/pipeline/document_source_cursor.h"
+#include "mongo/db/pipeline/document_source/document_source_cursor.h"
 #include "mongo/db/pipeline/expression_context.h"
 #include "mongo/db/pipeline/field_path.h"
 #include "mongo/db/query/plan_executor.h"
diff --git a/src/mongo/db/pipeline/document_source_geo_near_test.cpp b/src/mongo/db/pipeline/document_source/document_source_geo_near_test.cpp
similarity index 97%
rename from src/mongo/db/pipeline/document_source_geo_near_test.cpp
rename to src/mongo/db/pipeline/document_source/document_source_geo_near_test.cpp
index b9e73e6f8b..b535a2bbfb 100644
--- a/src/mongo/db/pipeline/document_source_geo_near_test.cpp
+++ b/src/mongo/db/pipeline/document_source/document_source_geo_near_test.cpp
@@ -35,8 +35,8 @@
 #include "mongo/bson/json.h"
 #include "mongo/db/exec/document_value/document_value_test_util.h"
 #include "mongo/db/pipeline/aggregation_context_fixture.h"
-#include "mongo/db/pipeline/document_source_geo_near.h"
-#include "mongo/db/pipeline/document_source_limit.h"
+#include "mongo/db/pipeline/document_source/document_source_geo_near.h"
+#include "mongo/db/pipeline/document_source/document_source_limit.h"
 #include "mongo/db/pipeline/pipeline.h"
 
 namespace mongo {
diff --git a/src/mongo/db/pipeline/document_source_graph_lookup.cpp b/src/mongo/db/pipeline/document_source/document_source_graph_lookup.cpp
similarity index 99%
rename from src/mongo/db/pipeline/document_source_graph_lookup.cpp
rename to src/mongo/db/pipeline/document_source/document_source_graph_lookup.cpp
index eca4b8b821..8d32af773f 100644
--- a/src/mongo/db/pipeline/document_source_graph_lookup.cpp
+++ b/src/mongo/db/pipeline/document_source/document_source_graph_lookup.cpp
@@ -29,7 +29,7 @@
 
 #include "mongo/platform/basic.h"
 
-#include "mongo/db/pipeline/document_source_graph_lookup.h"
+#include "mongo/db/pipeline/document_source/document_source_graph_lookup.h"
 
 #include <memory>
 
@@ -40,8 +40,8 @@
 #include "mongo/db/exec/document_value/value.h"
 #include "mongo/db/jsobj.h"
 #include "mongo/db/pipeline/document_path_support.h"
-#include "mongo/db/pipeline/document_source_merge_gen.h"
-#include "mongo/db/pipeline/expression.h"
+#include "mongo/db/pipeline/document_source/document_source_merge_gen.h"
+#include "mongo/db/pipeline/expression/expression.h"
 #include "mongo/db/pipeline/expression_context.h"
 #include "mongo/db/query/query_knobs_gen.h"
 #include "mongo/db/query/query_planner_common.h"
diff --git a/src/mongo/db/pipeline/document_source_graph_lookup.h b/src/mongo/db/pipeline/document_source/document_source_graph_lookup.h
similarity index 98%
rename from src/mongo/db/pipeline/document_source_graph_lookup.h
rename to src/mongo/db/pipeline/document_source/document_source_graph_lookup.h
index ee930e1a01..d0f041084c 100644
--- a/src/mongo/db/pipeline/document_source_graph_lookup.h
+++ b/src/mongo/db/pipeline/document_source/document_source_graph_lookup.h
@@ -30,9 +30,9 @@
 #pragma once
 
 #include "mongo/db/exec/document_value/value_comparator.h"
-#include "mongo/db/pipeline/document_source.h"
-#include "mongo/db/pipeline/document_source_unwind.h"
-#include "mongo/db/pipeline/expression.h"
+#include "mongo/db/pipeline/document_source/document_source.h"
+#include "mongo/db/pipeline/document_source/document_source_unwind.h"
+#include "mongo/db/pipeline/expression/expression.h"
 #include "mongo/db/pipeline/lookup_set_cache.h"
 
 namespace mongo {
diff --git a/src/mongo/db/pipeline/document_source_graph_lookup_test.cpp b/src/mongo/db/pipeline/document_source/document_source_graph_lookup_test.cpp
similarity index 99%
rename from src/mongo/db/pipeline/document_source_graph_lookup_test.cpp
rename to src/mongo/db/pipeline/document_source/document_source_graph_lookup_test.cpp
index d22ee4b60b..707e7ac590 100644
--- a/src/mongo/db/pipeline/document_source_graph_lookup_test.cpp
+++ b/src/mongo/db/pipeline/document_source/document_source_graph_lookup_test.cpp
@@ -36,8 +36,8 @@
 #include "mongo/db/exec/document_value/document.h"
 #include "mongo/db/exec/document_value/document_value_test_util.h"
 #include "mongo/db/pipeline/aggregation_context_fixture.h"
-#include "mongo/db/pipeline/document_source_graph_lookup.h"
-#include "mongo/db/pipeline/document_source_mock.h"
+#include "mongo/db/pipeline/document_source/document_source_graph_lookup.h"
+#include "mongo/db/pipeline/document_source/document_source_mock.h"
 #include "mongo/db/pipeline/process_interface/stub_mongo_process_interface.h"
 #include "mongo/unittest/unittest.h"
 #include "mongo/util/assert_util.h"
diff --git a/src/mongo/db/pipeline/document_source_group.cpp b/src/mongo/db/pipeline/document_source/document_source_group.cpp
similarity index 99%
rename from src/mongo/db/pipeline/document_source_group.cpp
rename to src/mongo/db/pipeline/document_source/document_source_group.cpp
index 1cb4cd7d30..cecbc0705b 100644
--- a/src/mongo/db/pipeline/document_source_group.cpp
+++ b/src/mongo/db/pipeline/document_source/document_source_group.cpp
@@ -35,10 +35,10 @@
 #include "mongo/db/exec/document_value/document.h"
 #include "mongo/db/exec/document_value/value.h"
 #include "mongo/db/exec/document_value/value_comparator.h"
-#include "mongo/db/pipeline/accumulation_statement.h"
-#include "mongo/db/pipeline/accumulator.h"
-#include "mongo/db/pipeline/document_source_group.h"
-#include "mongo/db/pipeline/expression.h"
+#include "mongo/db/pipeline/accumulator/accumulation_statement.h"
+#include "mongo/db/pipeline/accumulator/accumulator.h"
+#include "mongo/db/pipeline/document_source/document_source_group.h"
+#include "mongo/db/pipeline/expression/expression.h"
 #include "mongo/db/pipeline/expression_context.h"
 #include "mongo/db/pipeline/lite_parsed_document_source.h"
 #include "mongo/db/stats/resource_consumption_metrics.h"
diff --git a/src/mongo/db/pipeline/document_source_group.h b/src/mongo/db/pipeline/document_source/document_source_group.h
similarity index 98%
rename from src/mongo/db/pipeline/document_source_group.h
rename to src/mongo/db/pipeline/document_source/document_source_group.h
index 5dc398800c..6abf0cf685 100644
--- a/src/mongo/db/pipeline/document_source_group.h
+++ b/src/mongo/db/pipeline/document_source/document_source_group.h
@@ -32,9 +32,9 @@
 #include <memory>
 #include <utility>
 
-#include "mongo/db/pipeline/accumulation_statement.h"
-#include "mongo/db/pipeline/accumulator.h"
-#include "mongo/db/pipeline/document_source.h"
+#include "mongo/db/pipeline/accumulator/accumulation_statement.h"
+#include "mongo/db/pipeline/accumulator/accumulator.h"
+#include "mongo/db/pipeline/document_source/document_source.h"
 #include "mongo/db/pipeline/memory_usage_tracker.h"
 #include "mongo/db/pipeline/transformer_interface.h"
 #include "mongo/db/sorter/sorter.h"
diff --git a/src/mongo/db/pipeline/document_source_group_test.cpp b/src/mongo/db/pipeline/document_source/document_source_group_test.cpp
similarity index 99%
rename from src/mongo/db/pipeline/document_source_group_test.cpp
rename to src/mongo/db/pipeline/document_source/document_source_group_test.cpp
index de6252449e..7bd44f59a5 100644
--- a/src/mongo/db/pipeline/document_source_group_test.cpp
+++ b/src/mongo/db/pipeline/document_source/document_source_group_test.cpp
@@ -46,9 +46,9 @@
 #include "mongo/db/pipeline/aggregation_context_fixture.h"
 #include "mongo/db/pipeline/aggregation_request_helper.h"
 #include "mongo/db/pipeline/dependencies.h"
-#include "mongo/db/pipeline/document_source_group.h"
-#include "mongo/db/pipeline/document_source_mock.h"
-#include "mongo/db/pipeline/expression.h"
+#include "mongo/db/pipeline/document_source/document_source_group.h"
+#include "mongo/db/pipeline/document_source/document_source_mock.h"
+#include "mongo/db/pipeline/expression/expression.h"
 #include "mongo/db/pipeline/expression_context_for_test.h"
 #include "mongo/db/query/query_test_service_context.h"
 #include "mongo/dbtests/dbtests.h"
diff --git a/src/mongo/db/pipeline/document_source_index_stats.cpp b/src/mongo/db/pipeline/document_source/document_source_index_stats.cpp
similarity index 97%
rename from src/mongo/db/pipeline/document_source_index_stats.cpp
rename to src/mongo/db/pipeline/document_source/document_source_index_stats.cpp
index ad6d600e74..037411ac87 100644
--- a/src/mongo/db/pipeline/document_source_index_stats.cpp
+++ b/src/mongo/db/pipeline/document_source/document_source_index_stats.cpp
@@ -29,7 +29,7 @@
 
 #include "mongo/platform/basic.h"
 
-#include "mongo/db/pipeline/document_source_index_stats.h"
+#include "mongo/db/pipeline/document_source/document_source_index_stats.h"
 
 #include "mongo/db/pipeline/lite_parsed_document_source.h"
 #include "mongo/db/server_options.h"
diff --git a/src/mongo/db/pipeline/document_source_index_stats.h b/src/mongo/db/pipeline/document_source/document_source_index_stats.h
similarity index 98%
rename from src/mongo/db/pipeline/document_source_index_stats.h
rename to src/mongo/db/pipeline/document_source/document_source_index_stats.h
index f70a3d4838..8155a315a8 100644
--- a/src/mongo/db/pipeline/document_source_index_stats.h
+++ b/src/mongo/db/pipeline/document_source/document_source_index_stats.h
@@ -30,7 +30,7 @@
 #pragma once
 
 #include "mongo/db/collection_index_usage_tracker.h"
-#include "mongo/db/pipeline/document_source.h"
+#include "mongo/db/pipeline/document_source/document_source.h"
 
 namespace mongo {
 
diff --git a/src/mongo/db/pipeline/document_source_internal_convert_bucket_index_stats.cpp b/src/mongo/db/pipeline/document_source/document_source_internal_convert_bucket_index_stats.cpp
similarity index 98%
rename from src/mongo/db/pipeline/document_source_internal_convert_bucket_index_stats.cpp
rename to src/mongo/db/pipeline/document_source/document_source_internal_convert_bucket_index_stats.cpp
index 3e523696eb..cdf7c1b767 100644
--- a/src/mongo/db/pipeline/document_source_internal_convert_bucket_index_stats.cpp
+++ b/src/mongo/db/pipeline/document_source/document_source_internal_convert_bucket_index_stats.cpp
@@ -29,7 +29,7 @@
 
 #include "mongo/platform/basic.h"
 
-#include "mongo/db/pipeline/document_source_internal_convert_bucket_index_stats.h"
+#include "mongo/db/pipeline/document_source/document_source_internal_convert_bucket_index_stats.h"
 
 #include "mongo/bson/bsonobj.h"
 #include "mongo/db/exec/document_value/document.h"
diff --git a/src/mongo/db/pipeline/document_source_internal_convert_bucket_index_stats.h b/src/mongo/db/pipeline/document_source/document_source_internal_convert_bucket_index_stats.h
similarity index 98%
rename from src/mongo/db/pipeline/document_source_internal_convert_bucket_index_stats.h
rename to src/mongo/db/pipeline/document_source/document_source_internal_convert_bucket_index_stats.h
index 498518ee95..0ce18e241f 100644
--- a/src/mongo/db/pipeline/document_source_internal_convert_bucket_index_stats.h
+++ b/src/mongo/db/pipeline/document_source/document_source_internal_convert_bucket_index_stats.h
@@ -29,7 +29,7 @@
 
 #pragma once
 
-#include "mongo/db/pipeline/document_source.h"
+#include "mongo/db/pipeline/document_source/document_source.h"
 
 namespace mongo {
 
diff --git a/src/mongo/db/pipeline/document_source_internal_inhibit_optimization.cpp b/src/mongo/db/pipeline/document_source/document_source_internal_inhibit_optimization.cpp
similarity index 96%
rename from src/mongo/db/pipeline/document_source_internal_inhibit_optimization.cpp
rename to src/mongo/db/pipeline/document_source/document_source_internal_inhibit_optimization.cpp
index 10f10171f0..e919cbf4cc 100644
--- a/src/mongo/db/pipeline/document_source_internal_inhibit_optimization.cpp
+++ b/src/mongo/db/pipeline/document_source/document_source_internal_inhibit_optimization.cpp
@@ -29,7 +29,7 @@
 
 #include "mongo/platform/basic.h"
 
-#include "mongo/db/pipeline/document_source_internal_inhibit_optimization.h"
+#include "mongo/db/pipeline/document_source/document_source_internal_inhibit_optimization.h"
 
 namespace mongo {
 
diff --git a/src/mongo/db/pipeline/document_source_internal_inhibit_optimization.h b/src/mongo/db/pipeline/document_source/document_source_internal_inhibit_optimization.h
similarity index 98%
rename from src/mongo/db/pipeline/document_source_internal_inhibit_optimization.h
rename to src/mongo/db/pipeline/document_source/document_source_internal_inhibit_optimization.h
index cf23b7735b..d2c083dbaa 100644
--- a/src/mongo/db/pipeline/document_source_internal_inhibit_optimization.h
+++ b/src/mongo/db/pipeline/document_source/document_source_internal_inhibit_optimization.h
@@ -29,7 +29,7 @@
 
 #pragma once
 
-#include "mongo/db/pipeline/document_source.h"
+#include "mongo/db/pipeline/document_source/document_source.h"
 
 namespace mongo {
 
diff --git a/src/mongo/db/pipeline/document_source_internal_shard_filter.cpp b/src/mongo/db/pipeline/document_source/document_source_internal_shard_filter.cpp
similarity index 98%
rename from src/mongo/db/pipeline/document_source_internal_shard_filter.cpp
rename to src/mongo/db/pipeline/document_source/document_source_internal_shard_filter.cpp
index a8b112ae83..b55c4959a7 100644
--- a/src/mongo/db/pipeline/document_source_internal_shard_filter.cpp
+++ b/src/mongo/db/pipeline/document_source/document_source_internal_shard_filter.cpp
@@ -31,7 +31,7 @@
 
 #include "mongo/platform/basic.h"
 
-#include "mongo/db/pipeline/document_source_internal_shard_filter.h"
+#include "mongo/db/pipeline/document_source/document_source_internal_shard_filter.h"
 
 #include "mongo/db/exec/document_value/document.h"
 #include "mongo/logv2/log.h"
diff --git a/src/mongo/db/pipeline/document_source_internal_shard_filter.h b/src/mongo/db/pipeline/document_source/document_source_internal_shard_filter.h
similarity index 98%
rename from src/mongo/db/pipeline/document_source_internal_shard_filter.h
rename to src/mongo/db/pipeline/document_source/document_source_internal_shard_filter.h
index d5f18fd1ab..660c90c90c 100644
--- a/src/mongo/db/pipeline/document_source_internal_shard_filter.h
+++ b/src/mongo/db/pipeline/document_source/document_source_internal_shard_filter.h
@@ -30,7 +30,7 @@
 #pragma once
 
 #include "mongo/db/exec/shard_filterer.h"
-#include "mongo/db/pipeline/document_source.h"
+#include "mongo/db/pipeline/document_source/document_source.h"
 
 namespace mongo {
 
diff --git a/src/mongo/db/pipeline/document_source_internal_shard_filter_test.cpp b/src/mongo/db/pipeline/document_source/document_source_internal_shard_filter_test.cpp
similarity index 97%
rename from src/mongo/db/pipeline/document_source_internal_shard_filter_test.cpp
rename to src/mongo/db/pipeline/document_source/document_source_internal_shard_filter_test.cpp
index 55a01a23a3..682f850d4e 100644
--- a/src/mongo/db/pipeline/document_source_internal_shard_filter_test.cpp
+++ b/src/mongo/db/pipeline/document_source/document_source_internal_shard_filter_test.cpp
@@ -34,8 +34,8 @@
 #include "mongo/db/exec/document_value/document_value_test_util.h"
 #include "mongo/db/exec/shard_filterer.h"
 #include "mongo/db/pipeline/aggregation_context_fixture.h"
-#include "mongo/db/pipeline/document_source_internal_shard_filter.h"
-#include "mongo/db/pipeline/document_source_mock.h"
+#include "mongo/db/pipeline/document_source/document_source_internal_shard_filter.h"
+#include "mongo/db/pipeline/document_source/document_source_mock.h"
 #include "mongo/db/pipeline/pipeline.h"
 #include "mongo/unittest/unittest.h"
 
diff --git a/src/mongo/db/pipeline/document_source_internal_split_pipeline.cpp b/src/mongo/db/pipeline/document_source/document_source_internal_split_pipeline.cpp
similarity index 98%
rename from src/mongo/db/pipeline/document_source_internal_split_pipeline.cpp
rename to src/mongo/db/pipeline/document_source/document_source_internal_split_pipeline.cpp
index c2721ff77d..5379a76bdf 100644
--- a/src/mongo/db/pipeline/document_source_internal_split_pipeline.cpp
+++ b/src/mongo/db/pipeline/document_source/document_source_internal_split_pipeline.cpp
@@ -29,7 +29,7 @@
 
 #include "mongo/platform/basic.h"
 
-#include "mongo/db/pipeline/document_source_internal_split_pipeline.h"
+#include "mongo/db/pipeline/document_source/document_source_internal_split_pipeline.h"
 
 namespace mongo {
 
diff --git a/src/mongo/db/pipeline/document_source_internal_split_pipeline.h b/src/mongo/db/pipeline/document_source/document_source_internal_split_pipeline.h
similarity index 98%
rename from src/mongo/db/pipeline/document_source_internal_split_pipeline.h
rename to src/mongo/db/pipeline/document_source/document_source_internal_split_pipeline.h
index 6ac88f8a82..c49cf084f6 100644
--- a/src/mongo/db/pipeline/document_source_internal_split_pipeline.h
+++ b/src/mongo/db/pipeline/document_source/document_source_internal_split_pipeline.h
@@ -29,7 +29,7 @@
 
 #pragma once
 
-#include "mongo/db/pipeline/document_source.h"
+#include "mongo/db/pipeline/document_source/document_source.h"
 
 namespace mongo {
 
diff --git a/src/mongo/db/pipeline/document_source_internal_split_pipeline_test.cpp b/src/mongo/db/pipeline/document_source/document_source_internal_split_pipeline_test.cpp
similarity index 96%
rename from src/mongo/db/pipeline/document_source_internal_split_pipeline_test.cpp
rename to src/mongo/db/pipeline/document_source/document_source_internal_split_pipeline_test.cpp
index 4b52c29e05..3e461cbb07 100644
--- a/src/mongo/db/pipeline/document_source_internal_split_pipeline_test.cpp
+++ b/src/mongo/db/pipeline/document_source/document_source_internal_split_pipeline_test.cpp
@@ -35,7 +35,7 @@
 
 #include "mongo/db/operation_context_noop.h"
 #include "mongo/db/pipeline/aggregation_context_fixture.h"
-#include "mongo/db/pipeline/document_source_internal_split_pipeline.h"
+#include "mongo/db/pipeline/document_source/document_source_internal_split_pipeline.h"
 #include "mongo/db/pipeline/stage_constraints.h"
 
 namespace mongo {
diff --git a/src/mongo/db/pipeline/document_source_internal_unpack_bucket.cpp b/src/mongo/db/pipeline/document_source/document_source_internal_unpack_bucket.cpp
similarity index 98%
rename from src/mongo/db/pipeline/document_source_internal_unpack_bucket.cpp
rename to src/mongo/db/pipeline/document_source/document_source_internal_unpack_bucket.cpp
index 2fa8291fee..f672f1c8c4 100644
--- a/src/mongo/db/pipeline/document_source_internal_unpack_bucket.cpp
+++ b/src/mongo/db/pipeline/document_source/document_source_internal_unpack_bucket.cpp
@@ -32,7 +32,7 @@
 #include <algorithm>
 #include <iterator>
 
-#include "mongo/db/pipeline/document_source_internal_unpack_bucket.h"
+#include "mongo/db/pipeline/document_source/document_source_internal_unpack_bucket.h"
 
 #include <string>
 #include <type_traits>
@@ -42,13 +42,13 @@
 #include "mongo/db/matcher/expression.h"
 #include "mongo/db/matcher/expression_algo.h"
 #include "mongo/db/matcher/expression_internal_expr_comparison.h"
-#include "mongo/db/pipeline/document_source_add_fields.h"
-#include "mongo/db/pipeline/document_source_group.h"
-#include "mongo/db/pipeline/document_source_match.h"
-#include "mongo/db/pipeline/document_source_project.h"
-#include "mongo/db/pipeline/document_source_sample.h"
-#include "mongo/db/pipeline/document_source_single_document_transformation.h"
-#include "mongo/db/pipeline/document_source_sort.h"
+#include "mongo/db/pipeline/document_source/document_source_add_fields.h"
+#include "mongo/db/pipeline/document_source/document_source_group.h"
+#include "mongo/db/pipeline/document_source/document_source_match.h"
+#include "mongo/db/pipeline/document_source/document_source_project.h"
+#include "mongo/db/pipeline/document_source/document_source_sample.h"
+#include "mongo/db/pipeline/document_source/document_source_single_document_transformation.h"
+#include "mongo/db/pipeline/document_source/document_source_sort.h"
 #include "mongo/db/pipeline/expression_context.h"
 #include "mongo/db/pipeline/lite_parsed_document_source.h"
 #include "mongo/db/query/util/make_data_structure.h"
diff --git a/src/mongo/db/pipeline/document_source_internal_unpack_bucket.h b/src/mongo/db/pipeline/document_source/document_source_internal_unpack_bucket.h
similarity index 98%
rename from src/mongo/db/pipeline/document_source_internal_unpack_bucket.h
rename to src/mongo/db/pipeline/document_source/document_source_internal_unpack_bucket.h
index d6c60c4d88..6e66b3e8f7 100644
--- a/src/mongo/db/pipeline/document_source_internal_unpack_bucket.h
+++ b/src/mongo/db/pipeline/document_source/document_source_internal_unpack_bucket.h
@@ -33,8 +33,8 @@
 #include <vector>
 
 #include "mongo/db/exec/bucket_unpacker.h"
-#include "mongo/db/pipeline/document_source.h"
-#include "mongo/db/pipeline/document_source_match.h"
+#include "mongo/db/pipeline/document_source/document_source.h"
+#include "mongo/db/pipeline/document_source/document_source_match.h"
 
 namespace mongo {
 class DocumentSourceInternalUnpackBucket : public DocumentSource {
diff --git a/src/mongo/db/pipeline/document_source_limit.cpp b/src/mongo/db/pipeline/document_source/document_source_limit.cpp
similarity index 97%
rename from src/mongo/db/pipeline/document_source_limit.cpp
rename to src/mongo/db/pipeline/document_source/document_source_limit.cpp
index 1f8051fa1d..c815286009 100644
--- a/src/mongo/db/pipeline/document_source_limit.cpp
+++ b/src/mongo/db/pipeline/document_source/document_source_limit.cpp
@@ -29,12 +29,12 @@
 
 #include "mongo/platform/basic.h"
 
-#include "mongo/db/pipeline/document_source_limit.h"
+#include "mongo/db/pipeline/document_source/document_source_limit.h"
 
 #include "mongo/db/exec/document_value/document.h"
 #include "mongo/db/exec/document_value/value.h"
 #include "mongo/db/jsobj.h"
-#include "mongo/db/pipeline/expression.h"
+#include "mongo/db/pipeline/expression/expression.h"
 #include "mongo/db/pipeline/expression_context.h"
 #include "mongo/db/pipeline/lite_parsed_document_source.h"
 #include "mongo/util/str.h"
